/*
* Creates a minimum DCC command station 
 */
 
//#include <EEPROM.h>
 
#include <DCCPacket.h>
#include <DCCPacketQueue.h>
#include <DCCPacketScheduler.h>

DCCPacketScheduler dcc;

long count = 0;
uint16_t Address0 = 16; //adr-1 = 4
uint16_t Address1 = 17;
uint16_t Address2 = 18;
uint16_t Address3 = 19;
uint16_t Address4 = 20; //adr-2 = 5
uint16_t Address5 = 22;

void setup() {
  pinMode(4, OUTPUT);
  digitalWrite(4, LOW);
  pinMode(6, OUTPUT);
  digitalWrite(6, LOW);
  
  dcc.setup(6);   //DCC OUT PIN
  dcc.setpower(true);
  digitalWrite(4, HIGH);
}

void loop() {
  FB();
  dcc.update();
  count++;
}

// FB part:
//--------------------------------------------------------------------------------------------
 int sensivity = 500;      // уровень чувствительности
 boolean flag0 = false;    // метка о том, что препятствие уже посчитали
 boolean flag1 = false;
 boolean flag2 = false;
 boolean flag3 = false;
 boolean flag4 = false;
 boolean flag5 = false;

void FB(){
  int sV0 = analogRead(A0);  // read the input on analog pin:
  int sV1 = analogRead(A1);
  int sV2 = analogRead(A2);
  int sV3 = analogRead(A3);
  int sV4 = analogRead(A4);
  int sV5 = analogRead(A5);
// датчик 0
  if ((sV0 < sensivity) && (flag0 == false)){    // сравниваем. Если меньше И препятствие еще не зафиксировано
     dcc.setBasicAccessoryPos(Address0, false);  //dcc.setBasicAccessoryPos(Address, (Direction & 0x01));
     flag0 = true;                               // ставим метку, что препятствие посчитано - пока она есть, счетчтик не увеличивать
     }
  if ((sV0 > sensivity) && (flag0 == true)){     // опять сравниваем. Если больше И препятствие уже было зафиксировано
     dcc.setBasicAccessoryPos(Address0, true);
     flag0 = false;                              // сбрасываем метку, т.е. следующее препятствие будет снова посчитано
     }

// датчик 1
  if ((sV1 < sensivity) && (flag1 == false)){
     dcc.setBasicAccessoryPos(Address1, false);
     flag1 = true;
     }
  if ((sV1 > sensivity) && (flag1 == true)){
     dcc.setBasicAccessoryPos(Address1, true);
     flag1 = false;
   }
   
// датчик 2
  if ((sV2 < sensivity) && (flag2 == false)){
     dcc.setBasicAccessoryPos(Address2, false);
     flag2 = true;
     }
  if ((sV2 > sensivity) && (flag2 == true)){
     dcc.setBasicAccessoryPos(Address2, true);
     flag2 = false;
     }

// датчик 3 
  if ((sV3 < sensivity) && (flag3 == false)){
     dcc.setBasicAccessoryPos(Address3, false);
     flag3 = true;
     }
  if ((sV3 > sensivity) && (flag3 == true)){
     dcc.setBasicAccessoryPos(Address3, true);
     flag3 = false;
     }

// датчик 4
  if ((sV4 < sensivity) && (flag4 == false)){
     dcc.setBasicAccessoryPos(Address4, false);
     flag4 = true;
     }
  if ((sV4 > sensivity) && (flag4 == true)){
     dcc.setBasicAccessoryPos(Address4, true);
     flag4 = false;
     }

// датчик 5
  if ((sV5 < sensivity) && (flag5 == false)){
     dcc.setBasicAccessoryPos(Address5, false);
     flag5 = true;
     }
  if ((sV5 > sensivity) && (flag5 == true)){
     dcc.setBasicAccessoryPos(Address5, true);
     flag5 = false;
     }
}
